"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ad_record_1 = require("../records/ad.record");
const db_1 = require("../utils/db");
const defaultObj = new ad_record_1.AdRecord({
    title: 'Test Name',
    description: 'blah',
    url: 'htt[s://www.google.com',
    price: 0,
    lat: 9,
    lon: 9,
});
afterAll(() => __awaiter(void 0, void 0, void 0, function* () {
    yield db_1.pool.end();
}));
test('Can buildAdReocrd', () => {
    const ad = new ad_record_1.AdRecord(defaultObj);
    expect(ad.title).toBe('Test Name');
    expect(ad.description).toBe('blah');
});
test('Validate invalid price', () => {
    expect(() => new ad_record_1.AdRecord(Object.assign(Object.assign({}, defaultObj), { price: -3 }))).toThrow('Cena nie moze byc mniejsza niz 0 lub przekraczac 9 999 999 PLN');
});
test('AdRecord.insert returns UUID', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = new ad_record_1.AdRecord({
        // id: 'testowe-id',
        title: 'test123',
        description: 'insert test',
        price: 10,
        url: 'https://google.com',
        lat: 52,
        lon: 21
    });
    yield ad.insert();
    expect(ad.id).toBeDefined();
    expect(typeof ad.id).toBe('string');
}));
test('AdRecord.insert inserts data to database', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = new ad_record_1.AdRecord({
        // id: 'testowe-id',
        title: 'test123',
        description: 'insert test',
        price: 10,
        url: 'https://google.com',
        lat: 52,
        lon: 21
    });
    yield ad.insert();
    const foundAd = yield ad_record_1.AdRecord.getOne(ad.id);
    expect(foundAd).toBeDefined();
    expect(foundAd).not.toBeNull();
    expect(foundAd.id).toBe(ad.id);
}));
test('Validate getAll() method', () => __awaiter(void 0, void 0, void 0, function* () {
    const all = yield ad_record_1.AdRecord.getAll('Test');
    expect(all).toBeTruthy();
}));
// test('Validate getAll() - returns smaller amount of data', async () => {
//     const ads = await AdRecord.getAll('Test');
//     expect(ads[0].price).toBeUndefined()
// })
// @TODO Check all of the validation
//# sourceMappingURL=ad-record.test.js.map