import express, {json, Router} from "express";
import cors from 'cors';
import 'express-async-errors';
import { handleErrors, ValidationError } from "./utils/errors";
import rateLimit from 'express-rate-limit'
import { AdRecord } from "./records/ad.record";
import {AdEntity} from "./types";
import {adRouter} from "./routers/ad.router";


const app = express()
app.use(cors({
    origin: 'https://jb-portfolio.networkmanager.pl',
}));
app.use(json());
app.use(rateLimit({
    windowMs: 5 * 60 * 1000, // 15 minutes
    max: 100, // Limit each IP to 100 requests per `window` (here, per 15 minutes)
}))

// Routes

const router = Router();


router.use('/ad', adRouter);

app.use('/api',router)

// app.get('/', async(req, res) => {
//     throw new ValidationError("Daamn...")
// })

app.use(handleErrors);

app.listen(3001, '0.0.0.0', () => {
    console.log("Listening on port 3001")
});
