import {Request, Response, Router} from "express";
import {AdRecord} from "../records/ad.record";

export const adRouter = Router()

    .get('/search/:title?', async (req:Request, res: Response) => {

        const ads = await AdRecord.getAll(req.params.title ?? '')
        res.json(ads)
    })
    .get('/:id', async (req:Request, res: Response) => {
        const ad = await AdRecord.getOne(req.params.id);
        res.json(ad);
    })
    .post('/', async (req:Request, res: Response) => {
        const ad = new AdRecord(req.body);
        await ad.insert();
        res.json(ad);
    })
