"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decryptMessage = exports.encryptMessage = void 0;
//Checking the crypto module
const crypto = require('crypto');
const algorithm = 'aes-256-cbc';
//Encrypting text
const encryptMessage = (body) => __awaiter(void 0, void 0, void 0, function* () {
    const iv = yield crypto.randomBytes(16);
    const key = yield crypto.randomBytes(32);
    const cipher = crypto.createCipheriv(algorithm, Buffer.from(key), iv);
    let encrypted = cipher.update(body, 'utf8', 'hex');
    encrypted += cipher.final('hex');
    return {
        ivCrypto: iv.toString('hex'),
        keyCrypto: key.toString('hex'),
        body: encrypted
    };
});
exports.encryptMessage = encryptMessage;
// Decrypting text
const decryptMessage = (text) => __awaiter(void 0, void 0, void 0, function* () {
    const iv = Buffer.from(text.ivCrypto, 'hex');
    const key = Buffer.from(text.keyCrypto, 'hex');
    const decipher = crypto.createDecipheriv(algorithm, key, iv);
    let decrypted = decipher.update(text.body, 'hex', 'utf8');
    decrypted += decipher.final('utf8');
    return decrypted;
});
exports.decryptMessage = decryptMessage;
//# sourceMappingURL=crypto.js.map