"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importStar(require("express"));
const express_rate_limit_1 = __importDefault(require("express-rate-limit"));
const cors_1 = __importDefault(require("cors"));
const config_1 = require("./config/config");
const home_router_1 = require("./routers/home.router");
const message_router_1 = require("./routers/message.router");
const errors_1 = require("./utils/errors");
const app = (0, express_1.default)();
app.use((0, cors_1.default)({
    origin: `http://localhost:${config_1.config.PORT_CLIENT}`,
}));
app.use((0, express_rate_limit_1.default)({
    windowMs: 5 * 60 * 1000,
    max: 100
}));
app.use((0, express_1.json)());
app.use('/api/', home_router_1.homeRouter);
app.use('/api/message', message_router_1.messageRouter);
app.use(errors_1.handleErrors);
app.listen(config_1.config.PORT_SERVER, '0.0.0.0', () => {
    console.log(`PORT_SERVER ${config_1.config.PORT_SERVER}`);
    console.log(`PORT_CLIENT ${config_1.config.PORT_CLIENT}`);
});
//# sourceMappingURL=index.js.map