"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.messageRouter = void 0;
const message_record_1 = require("./../records/message.record");
const express_1 = __importDefault(require("express"));
exports.messageRouter = (0, express_1.default)()
    .get('/:sender?/:secretKey?', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    if (typeof req.params.sender === 'undefined' || typeof req.params.secretKey === 'undefined') {
        res
            .status(401)
            .json({
            isSucces: false,
            errMsg: 'Sender and SecretKey fields cannot be empty',
        });
    }
    else {
        const data = {
            sender: req.params.sender,
            secretKey: req.params.secretKey
        };
        const msg = yield message_record_1.MessageRecord.getOne(data);
        if (!msg) {
            res
                .status(401)
                .json({
                isSucces: false,
                errMsg: 'No secret message has been found for the given cirterias',
            });
        }
        else {
            res
                .status(200)
                .json(msg);
        }
    }
}))
    .post('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    if (!/^[a-zA-Z0-9]+$/.test(req.body.sender)
        || req.body.sender == ''
        || typeof req.body.sender == 'undefined'
        || req.body.body == ''
        || typeof req.body.body == 'undefined') {
        res
            .status(401)
            .json({
            isSukcess: false,
            errMsg: 'Message or sender field are empty or special characters were used in sender field (only letters and digits are allowed)',
        });
    }
    else {
        const msg = new message_record_1.MessageRecord(req.body);
        const data = yield msg.insert();
        if (!data.isSucces) {
            res
                .status(500)
                .json({
                isSukcess: false,
                errMsg: 'Something went wrong. Try again later',
            });
        }
        else {
            res
                .status(200)
                .json({
                isSukcess: true,
                secretKey: data.secretKey,
                sender: data.sender
            });
        }
    }
}));
//# sourceMappingURL=message.router.js.map